
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>《OpenACC并行程序设计：性能优化实践指南》一 1.3　Amdahl定律及其扩展 / iVAN</title>

    <meta name="description" content="《OpenACC并行程序设计：性能优化实践指南》一 1.3　Amdahl定律及其扩展 1.3 Amdahl定律及其扩展 绘制任务运行时间,可以看到并行增加应用程序的扩展行为.并行计算的理论性能:运行在有N个处理单元的并行计算机上,理论上可以获得N倍加速.换一句话说,一个程序运行在10核处理器上可能获得10倍加速(对于固定大小的问题),在支持1000个并发执行线程的GPU上获得1000倍加速.开发人员依据Amdahl定律来讨论并行与串行间的加速比. 用计算机架构师Gene Amdahl来命名Amdahl定律.它不是实际上的定律,但是修改串行程序使其并行执行时,它相当接近模型理论加速">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">《OpenACC并行程序设计：性能优化实践指南》一 1.3　Amdahl定律及其扩展</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h3>1.3　Amdahl定律及其扩展</h3>
<p>绘制任务运行时间，可以看到并行增加应用程序的扩展行为。并行计算的理论性能：运行在有N个处理单元的并行计算机上，理论上可以获得N倍加速。换一句话说，一个程序运行在10核处理器上可能获得10倍加速（对于固定大小的问题），在支持1000个并发执行线程的GPU上获得1000倍加速。开发人员依据Amdahl定律来讨论并行与串行间的加速比。<br />
用计算机架构师Gene Amdahl来命名Amdahl定律。它不是实际上的定律，但是修改串行程序使其并行执行时，它相当接近模型理论加速比。为使这个近似值有效，在并行化时有必要保持问题规模相同，通常称为强扩展。换句话说，假定修改串行程序使其并行执行，在并行版本代码中程序执行的工作量并没有显著地变化。显然，并行部分可能运行得更快，这取决于硬件能力。因此，使用N个处理器，串行代码并行执行期望的加速比S(N)由程序可并行比例P和不可并行比例(1―P)决定。公式（1-1）显示了这种关系：<br /><a href="https://yqfile.alicdn.com/29637732b2f3bde99ddcc1260dd7ef1ab8925d7c.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzI5NjM3NzMyYjJmM2JkZTk5ZGRjYzEyNjBkZDdlZjFhYjg5MjVkN2MucG5n.jpg"></a></p>
<p>Amdahl定律告诉OpenACC开发人员在并行化程序时有两个目标：<br />
1.表达代码并行部分，使其尽可能快地执行。理想情况下，使用N个处理器有N倍加速。<br />
2.利用任何的技术或手段来减少1―P串行时间。<br />
并行部分代码执行很快使得程序运行时间主要由串行部分代码占据，这是有可能的。这是计算机架构师将强大的顺序处理器（如CPU）与并行处理器和协处理器混合使用的原因之一。<br />
理论上通过增加计数器，accTask.cpp忙工作的任务示例将在所有OpenACC设备上全速运行，因为它被设计成100%计算限制，意味着处理器是限制性能的系统组件。实际应用中通常要复杂很多，其性能可能受到存储器和网络带宽之类的其他因素影响。随着并行性的增加，许多并行应用程序的性能受到限制，因为它们严重依赖于存储器中的数据。因而增加更多的处理单元并不会提高性能，并且可能损失性能，处理单元大部分时间消耗在等待数据上。accFill_ex1.cpp和accFill_ex2.cpp示例都是存储器瓶颈，意味着存储子系统的性能限制了程序性能。<br />
计算机架构的缓存可以帮忙提高性能，在高速缓存存储器中预取和存放经常访问的或热点数据。这就是并行编程人员对局部性和流行为很感兴趣的原因。利用高数据局部性的程序通常运行得更快，因为它们可以用完寄存器或缓冲存储器。accTask.cpp示例就是一个例子，它使用一个寄存器并且在忙循环中没有其他的内存取操作。将数据流出存储器的程序也往往运行得更快，因此数据可以被预取到更快的高速缓冲存储器中。理想情况下，流程序完全不受存储子系统限制，呈现很好的扩展性。局部性和流行为的关键是对每个取出的数据项执行足够的计算来隐藏存储器事务的开销。从内存，跨网络，数据仓库或跨PCI总线取数据时，这点依旧成立。</p>
<h4>1.3.1　大O表示法和数据传输</h4>
<p>大O表示法是一个方便的方式来描述问题规模如何影响算法某些资源的消耗，例如处理器时间或存储器作为算法输入的函数。通过这种方式，计算科学家可以描述算法的最坏和平均情况运行时行为。可以用大O描述法来比较算法，以帮助理解并行算法的类型。哪些算法可能对每个取出的数据项表现出高计算性，确定适合OpenACC编程的算法。<br />
一些常见的大O增长率如下所示：<br />
O(1)：常量时间（或空间）算法，不管输入集合大小始终消耗相同资源。例如，索引向量中的单个元素不随时间或数据集的大小而变化，因此表现出O(1)运行时增长。<br />
O(N)：算法资源消耗随着输入问题规模N而线性增长。这对于循环数据集（大小为N）的算法是常见的，其中循环内的工作需要的时间是恒定的。<br />
O(N2)：性能与输入数据集大小的平方成正比。典型示例是在输入数据集上使用嵌套循环的算法，表现出O(N2)运行时。深层嵌套迭代通常显示更大的运行时（例如，三层循环导致O(N3)，四层循环导致O(N4)，依次类推）。<br />
有很多优秀的算法分析书籍，更精确和全面地讲解了大O表示法。其中最流行的一本书籍是&lt;&lt;算法导论&gt;&gt;（Cormen, Leiserson, &amp; Rivest, 2009）。在网络上也有许多谈论和讲授大O表示法和算法分析的资源。<br />
大多数计算领域的科学家和程序员都熟悉BLAS（基本线性代数子程序）库。BLAS是基本线性代数实际上的编程接口。为了保持竞争力，多数处理器供应商提供高度优化的BLAS库。也可使用强大的异构高性能稠密线程代数库，例如田纳西大学创新计算实验室的MAGMA项目。异构计算使用主机处理器（CPU）和很多OpenACC设备类型的计算能力。MAGMA通过使用所有的系统计算能力来获得高性能。MAGMA目前可以免费下载。<br />
根据三个不同的级别，随着数据和运行时需求的增加而构建BLAS。<br />
级别1：需要O(N)数据和O(N)任务的向量-向量操作。例如计算两个向量的内积，或通过常数乘法器缩放向量。<br />
级别2：需要O(N2)数据和O(N2)任务的矩阵-向量操作。例如矩阵-向量乘法，或单个右手三角求解。<br />
级别3：需要O(N2)数据和O(N3)任务的矩阵-向量操作，例如稠密矩阵-矩阵乘法。<br />
假定从主机向OpenACC设备传输N个浮点数值，表1-1说明了每个BLAS级别所要执行的全部任务。<br /><a href="https://yqfile.alicdn.com/70afd374cca94ed49d42b869d17b6544da39a7c0.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzcwYWZkMzc0Y2NhOTRlZDQ5ZDQyYjg2OWQxN2I2NTQ0ZGEzOWE3YzAucG5n.jpg"></a></p>
<p>可以看出级别3的BLAS操作应该高效执行，因为对于传输到OpenACC并行设备的每个浮点值执行O(N)任务。任务/数据的分析同样也能应用于非BLAS相关的计算问题。<br />
为了实现高性能需要尽量把数据保存在OpenACC设备和离处理器近的缓冲存储器上，这点是很明确的。在这之后，为了获得高性能需要对每个数据执行尽可能多的计算，就像级别3的BLAS操作。创建一个有许多低算术密度计算的流水线有助于提高性能，但是只有当每个操作使得OpenACC设备足够忙碌，以至可以隐藏任何设备启动延时时，才能提高性能。或者，结合多个例如级别1和级别2 BLAS操作的低密度操作，可能会（有时会显著地）提高性能。Kernel子句可以帮助做到这一点。<br />
之前讨论的可以总结出关于异构模型编程的三条规则：<br />
在OpenACC设备上获取数据并且把数据保存在设备上。<br />
这将尽可能地减少或消除数据传输开销。特别地，OpenACC编程人员应该学习使用present()子句和条件数据传输子句（例如present_or_copy()）。当程序运行在共享内存设备（例如多核CPU）上时，允许OpenACC运行时消除数据传输。<br />
给OpenACC设备执行足够多的任务。<br />
快速运行并行代码段的一个挑战是OpenACC设备的启动时间大于或等于运行时间。记住大多数现代OpenACC处理器能够实现多个TF/s（兆浮点/秒）性能。基本上应用程序必须每微秒执行1百万次操作才可以抵消在这些设备上启动并行代码段的开销。<br />
注意数据重用以避免存储器带宽限制。<br />
正如之前讨论的，针对高局部性的数据重用的编程，意味着编译器和硬件可以把<br />
数据保存在最高性能的寄存器和高速缓冲存储器中。OpenACC编译器还可以帮助优化寄存器复用和预取。同样，present_and_*子句可以复用已经传输到设备的数据。</p>
<h4>1.3.2　accTask.cpp代码的扩展性</h4>
<p>如前所述，accTask.cpp代码被设计为具有极高的局部性参考。实际上，这个代码使用一个寄存器变量，并且没有明显的存储器性能依赖。图1-11显示了在x86 CPU上accTask.cpp单线程版本的运行时间。<br />
请注意，单线程任务串行执行4个任务时，在Intel四核E5630 2.53GHz的系统上需要大约4倍的单任务时间（如57.4627/14.5115＝3.95）。这个比例是近似值，因为在时间测量中存在一些粒度。</p>
<p><a href="https://yqfile.alicdn.com/44b092ea6d9218c88de1c0600f9f847b677a293b.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzQ0YjA5MmVhNmQ5MjE4Yzg4ZGUxYzA2MDBmOWY4NDdiNjc3YTI5M2IucG5n.jpg"></a></p>
<p>使用bash脚本（如图1-12所示）来生成运行时间表，可用来查看运行时间与核数的关系。</p>
<p><a href="https://yqfile.alicdn.com/017cc8976d7ef45a0e307249c1d4d367f6dfc820.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzAxN2NjODk3NmQ3ZWY0NWEwZTMwNzI0OWMxZDRkMzY3ZjZkZmM4MjAucG5n.jpg"></a></p>
<p>图1-13阐明了一个运行时间相对于基于核数的单线程值的阶梯模式。换句话说，如果每个核超量订阅相同数量的任务，运行时间是相同的。例如，硬件核超量订阅2倍任务，运行时间是单线程时间的2倍。继续订阅超过处理核数的任务，依旧可以清楚地看到这个行为。</p>
<p><a href="https://yqfile.alicdn.com/6d69bb8d80ebeb0159b59bc3a2db19314fb5191a.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzZkNjliYjhkODBlYmViMDE1OWI1OWJjM2EyZGIxOTMxNGZiNTE5MWEucG5n.jpg"></a></p>
<p>如图1-14所示，使用PathScale Enzo OpenACC编译器编译运行在96核Cavium Thun-derX ARM64系统上的可执行文件，也可以看到类似的扩展性。</p>
<p><a href="https://yqfile.alicdn.com/835c103460d97f708a1c8a91faaa82a6c2e46f09.png" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzgzNWMxMDM0NjBkOTdmNzA4YTFjOGE5MWZhYWE4MmE2YzJlNDZmMDkucG5n.jpg"></a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 07:16:46</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%80%a7%e8%83%bd/" title="性能">性能</a>, <a href="https://www.iamivan.net/tag/%e9%ab%98%e6%80%a7%e8%83%bd/" title="高性能">高性能</a>, <a href="https://www.iamivan.net/tag/https/" title="HTTPS">HTTPS</a>, <a href="https://www.iamivan.net/tag/%e7%ae%97%e6%b3%95/" title="算法">算法</a>, <a href="https://www.iamivan.net/tag/%e7%ba%bf%e7%a8%8b/" title="线程">线程</a>, <a href="https://www.iamivan.net/tag/%e7%bc%96%e7%a8%8b/" title="编程">编程</a>, <a href="https://www.iamivan.net/tag/%e6%80%a7%e8%83%bd%e4%bc%98%e5%8c%96/" title="性能优化">性能优化</a>, <a href="https://www.iamivan.net/tag/%e5%b9%b6%e8%a1%8c%e8%ae%a1%e7%ae%97/" title="并行计算">并行计算</a>, <a href="https://www.iamivan.net/tag/screenshot/" title="ScreenShot">ScreenShot</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>《OpenACC并行程序设计：性能优化实践指南》一 1.3　Amdahl定律及其扩展的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MRDeNqz.html" rel="bookmark">《OpenACC并行程序设计：性能优化实践指南》一 导读</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 欢迎阅读本书,这是一本由浅入深的书籍,从初学者到高级开发人员,都可以通过本书了解OpenACC的相关知识.本书由世界各地的24位作者共同编著而成,他们在高度并行编程的教学和实践方面分享了自己的专业知识.书中的例子既有时效性又不会过时.每个章节都是自包含的,可用于自学,也可以作为课堂教学的一部分. 这是一本关于并行编程的书,不仅仅介绍OpenACC语法或从文档中收集的信息,更介绍了如何编写实际的.高性能的以及可移植的程序,这些程序可以运行在从CPU到GPU的大量设备上.具体而言,书中演示了使			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3rPrwz.html" rel="bookmark">《OpenACC并行程序设计：性能优化实践指南》一 1&period;1　简单的数据并行循环</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.1 简单的数据并行循环 在顺序处理器程序设计中,需要编写计算某个最终结果所需要的任务和数据操作的程序.通过创建OpenACC,编程人员可以插入编译指令给编译器提供信息,而这些编译指令是关于并行机会和数据在加速器与主机间来回传输的信息.结合编译器,程序员使用注记来创建.调试和优化并行代码,使得程序达到高性能. OpenACC帮助程序员编写高效的数据和任务并行软件. 数据并行关注跨多个并发执行线程的分布式数据操作.在计算机科学中,线程是串行执行一段代码的线程的缩写.通过使用多个线程,应用程序可以			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mq8vBRb.html" rel="bookmark">《OpenACC并行程序设计：性能优化实践指南》一 1&period;5　无锁编程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.5 无锁编程 互斥锁是用于同步进程或线程的常用机制,这些进程或线程需要访问并行程序中的一些共享资源.互斥锁就像它们名字所说的:如果一个线程锁住了资源,另一个线程希望访问它需要等待第一个线程解锁这个资源.一旦资源被解锁,第二个线程在处理这个资源时会一直锁住它.程序的线程必须遵守:一旦使用完共享资源尽快解锁,以保持程序执行流程. 由于OpenACC中没有锁,编程人员需要熟悉无锁编程和数据结构的概念.无锁方法保证至少一个执行该方法的线程的进展.可能存在某些线程可以被延迟的情况,但是保证至少一个线程			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pkeyA7b.html" rel="bookmark">《OpenACC并行程序设计：性能优化实践指南》一 1&period;4　并行执行和竞争条件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.4 并行执行和竞争条件 OpenACC并行化for循环(Fortran中是do循环),因此循环内的代码使用并发硬件执行线程并行执行. 循环内的变量i似乎是顺序递增的,但实际上在这个for循环中使用多个i变量的线程可能同时并行执行,这可能有点令人困惑.OpenACC不保证线程执行的顺序,注意这点非常重要.实际上,甚至不可能假设单调性.例如,很有可能第nCount―1次迭代实际上先于第0次迭代执行完. OpenACC不保证线程执行的顺序,注意这点非常重要. 总之,OpenACC编程人员不能也不应			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pL7ng8M.html" rel="bookmark">《OpenACC并行程序设计：性能优化实践指南》一 2&period;6　小结</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.6 小结 OpenACC是一种描述型并行编程模型.在本章中,通过一个测试函数的应用,使用了OpenACC的多种特性来描述并行度和数据操控,并针对特定平台对代码进行了优化.尽管使用的是PGI编译器和PGProf性能调试器,但类似的优化流程也是适用于任何支持OpenACC工具包的应用的. 1.获得应用程序的性能分析结果,辨识和挖掘代码中的可并行之处. 2.逐步向编译器描述代码中可挖掘出的并行性.如果主机端和设备端使用各自的存储器,这一步骤后获得的代码很可能会减速. 3.描述应用程序的数据移动.编			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bEdNanz.html" rel="bookmark">《OpenACC并行程序设计：性能优化实践指南》一 3&period;2　逐步性能提升</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				3.2 逐步性能提升 本书的示例表明,通过提交更多的活动和优化数据传输,使用性能分析驱动的开发可不断提升OpenACC应用程序的性能.图3-2列出了优化混合应用遵循的模式. 从应用准备开始性能优化周期,然后进行实际的性能测量,并对性能数据进行分析.基于这些数据,编程开发人员尝试减少性能问题,并重新开始整个过程.下面使用Score-P和Vampri讲解性能提升周期里的前三步,以CUDA加速粒子单元模拟为例,其中CUDA部分代码很容易用OpenACC实现代替来获得同样的结果.此外,还引入了各种优化步			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z7ZexZp.html" rel="bookmark">《OpenACC并行程序设计：性能优化实践指南》一 第1章  从串行编程到并行编程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第1章 从串行编程到并行编程 Rob Farber TechEnablement.com CEO/创始人 本章主要向读者介绍OpenACC,演示如何使用OpenACC编写运行在多核CPU和类似GPU加速器上的可移植并行程序,并展示如何在CPU和GPU上编译和运行OpenACC程序. 阅读本章后,读者将会理解以下内容: 如何创建.编译和运行OpenACC应用程序. 高性能OpenACC编程的三个准则. 数据并行和任务并行编程的基本概念. 理解大O表示法和Amdahl定律. 竞争条件.原子操作,以及			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0Rvnnz.html" rel="bookmark">《OpenACC并行程序设计：性能优化实践指南》一 第3章  使用Score-P和Vampir分析混合应用性能</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第3章 使用Score-P和Vampir分析混合应用性能 Guido Juckeland 德国亥姆霍兹联合会(HZDR)信息服务和计算机系 Robert Dietrich 德国德累斯顿工业大学 本章的目的是让读者熟悉逐步性能提升的概念,以及在向OpenACC应用程序添加其他并行模式时所涉及的工具.混合应用程序可能会遭受许多性能瓶颈,应用程序运行期间所有活动的整体图可以揭示如何提高整体性能. 阅读本章后,读者将会理解以下内容: 混合应用程序(例如,MPI+OpenACC)性能分析的术语和方法. 如			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDe6nKb.html" rel="bookmark">《OpenACC并行程序设计：性能优化实践指南》一 2&period;5　在多核系统中并行运行</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.5 在多核系统中并行运行 尽管本章使用了NVIDIA GPU,但OpenACC不是一个GPU编程模型,而是一种普遍适用的并行编程模型.尽管在2.4节中使用的循环优化技术仅适用于GPU,关于并行度和数据移动的技术手段适用于任意并行架构设备.本章使用的PGI编译器支持多种目标加速器,包括NVIDIA和AMD公司的GPU,以及多核x86 CPU.如果在多核CPU上开发和运行代码,将会发生什么呢?为多核目标平台重新编译代码,而不是将目标设定为tesla(见图2-29和图2-30). 如果运行可执行程			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM1Xobx.html" rel="bookmark" class="title">win7旗舰版IE出现故障该怎么解决</a>
					<div>
						  IE故障是每一位雨林木风win7旗舰版系统用户都会碰到的问题,不论是XP还是Win7和Win8系统,都不可避免会碰到.各种IE故障都会有相应的解决方法,比如说IE无法打开任何窗口,单击任何链接时无 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LzJAG6p.html" rel="bookmark" class="title">iOS 用故事版拉属性，属性重复</a>
					<div>
						问题描述 iOS 用故事版拉属性,属性重复 用故事版拉属性,把之前的故事版删了替换成成新的故事版, 结果一个属性显示关联两个属性 , 怎么解决啊? 解决方案 product 执行一下clean命令,不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7M04ajM.html" rel="bookmark" class="title">SQL Server 2000的新特性：bigint数据类型</a>
					<div>
						尽管int依然是SQL Server 2000中最主要的整数数据类型,但是SQL Server 2000还是新增加了整数数据类型bigint,它应用于整数超过int数据范围的场合. int数据类型所表 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8jGv3b.html" rel="bookmark" class="title">Outlook回复时关闭原邮件</a>
					<div>
						Outlook回复邮件时,点击reply,会弹出一张新的邮件,也就是打开了两个邮件的界面,如图: 但是如何把打开的这两个窗口,变成一个呢,也就是点击reply后原邮件自动关闭,剩下reply的邮件.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvKJYNp.html" rel="bookmark" class="title">SQL Server实现分页的方式</a>
					<div>
						2000: 首先获得所有的记录集合的存储过程: create PROCEDURE [dbo].[P_GetOrderNumber]ASselect count(orderid) from orders ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M91XPRM.html" rel="bookmark" class="title">使用Perl进行虚拟化环境的自动化管理</a>
					<div>
						概述 虚拟化作为云计算的基础,是目前一个重要的趋势.通过虚拟化可以提高 IT 资源和应用程序的效率和可用 性.基于内核的虚拟机 KVM 在 2008 年被 RedHat 收购后,在 IBM 和 Red ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDAL3lb.html" rel="bookmark" class="title">Excel工作表怎么导入Access数据库数据</a>
					<div>
						  Excel工作表怎么导入Access数据库数据            1.启动Excel 2013,打开需要导入Access数据库数据的工作表,在&quot;数据&quot;选项卡的&quot;获 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M62ONWM.html" rel="bookmark" class="title">CSS常见11条技巧与经验收集</a>
					<div>
						在使用css过程中难免会碰到一些常见的bug及浏览器兼容方面的处理,下面与大家分享下CSS常见的11技巧与经验,喜欢web前端的朋友可以参考下,希望对大家有所帮助   1.如何清除图片下方出现几像素的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlBWBLz.html" rel="bookmark" class="title">jquery获取当前点击对象的value方法</a>
					<div>
						 这篇文章主要介绍了jquery如何获取当前点击对象的value,需要的朋友可以参考下 例:获取ul中li的value值    首先,在html中我们要为每个li设置value值   代码如下: &l ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZd4gkM.html" rel="bookmark" class="title">快速切换win8输入法有妙招</a>
					<div>
						  一.使用Win键+空格键组合 当用户将鼠标移至右下角输入法图标处时,会在输入法图标上方提示用户,可以按Windows键 空格键来切换输入法.操作时,用户可以先按住Win键,然后按一下空格键,这时会 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo7YN3b.html" rel="bookmark" class="title">走出虚拟内存禁用误区的技巧</a>
					<div>
						最近大家都经常谈论的话题,就是DDR内存的大降价,DDR266从400多元的位置暴跌到200元左右,很多人都用上了512MB甚至1GB的内存,于是有一种观点也在部分玩家中流行起来,说是禁用虚拟内存.禁 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvGXDrp.html" rel="bookmark" class="title">U盘装系统找不到硬盘、c盘怎么办？</a>
					<div>
						  现今重装系统已经不再是技术人员的事情了,只要你有一款帮助你的U盘装装机大师,就可以为你的电脑装上你喜欢的系统.不过,在重装系统的时候,如果发现找不到硬盘或者是C盘了?那该怎么办呢?接下来,小编就来 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRwE88p.html" rel="bookmark" class="title">jsp过滤非法字符输入，防止XSS跨站攻击</a>
					<div>
						一.写一个过滤器 代码如下: package com.liufeng.sys.filter; import java.io.IOException; import java.io.PrintWrite ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z42qaPM.html" rel="bookmark" class="title">CentOS6 安装并破解Jira 7</a>
					<div>
						CentOS6 安装并破解Jira 7 JIRA软件是为您的软件团队的每个成员构建的,用来规划,跟踪和发布优秀的软件. https://confluence.atlassian.com/adminji ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQrakOM.html" rel="bookmark" class="title">高中学历自学android，做出这样的软件，可以找工作吗</a>
					<div>
						问题描述 高中学历自学android,做出这样的软件,可以找工作吗 感觉做出来啥感觉没有,就是数据库,解析json,绑定控件什么的,没什么技术 解决方案 第一,学历并不是什么问题,重要的是有技术,做多 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZE44ap.html" rel="bookmark" class="title">android使用ant自动打包&lpar;包括更改文件中的内容&rpar;</a>
					<div>
						在ant打包过程中的一些学习所得以及用于这个项目的build文件的大体思路如下: 首先配置好整个系统所需的ant编译环境,在build.properties中配置好相关的参数.(build.prope ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLmKnaz.html" rel="bookmark" class="title">爱加密与安百科技深度&OpenCurlyDoubleQuote;联姻&rdquo; 共同消弭企业&OpenCurlyDoubleQuote;安全孤岛&rdquo;</a>
					<div>
						日前,爱加密携手安百科技举行了一场&quot;洞悉未知风险,共建生态安全&quot;的战略合作发布会.爱加密CEO郭训平和安百科技CEO康伟在现场签署了战略合作协议,共同宣布双方将实现共享数据/互通技 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE6AxoM.html" rel="bookmark" class="title">查找并修复Android中的内存泄露&mdash;OutOfMemoryError</a>
					<div>
						[编者按]本文作者为来自南非约翰内斯堡的女程序员 Rebecca Franks,Rebecca 热衷于安卓开发,拥有4年安卓应用开发经验.有点完美主义者,喜爱美食. 本文系国内ITOM管理平台 One ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRqZqeb.html" rel="bookmark" class="title">openldap-fedora4系统下openlda2&period;3&period;39崩溃退出，文件大小超出限制</a>
					<div>
						问题描述 fedora4系统下openlda2.3.39崩溃退出,文件大小超出限制 添加删除操作都直接崩溃退出,报文件大小超出限制.但可以读出数据.感觉这是操作系统的问题吧.berkelydb版本是4 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Nleaz.html" rel="bookmark" class="title">视频平台Veenome融资50万美元</a>
					<div>
						初创公司Veenome目前获得50万美元种子资金, 该公司提供视频索引和发现服务.这些资金来自生态风险投资人.Google私有天使投资人.Dingman Center天使等等.对于起步仅有6个月的Ve ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn7NgAz.html" rel="bookmark" class="title">mysql-请教一个关于Mysql字段值连接问题</a>
					<div>
						问题描述 请教一个关于Mysql字段值连接问题 现在的需求是把某记录end的字段 和 下一条记录的begin字段作比较 ,如果是相邻的,并且continent和country字段相同,则把这两个记录合 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
									<a href="https://www.iamivan.net/a/zJAj2Vp.html" class="thumbnail">
				<img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxMzExMDcxMTM4MDM3MTg/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2YjNWNVlXNW5YM0JsYm1jPS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L1NvdXRoRWFzdA==.jpg">
							</a>
							<div class="info"   >
					<a href="https://www.iamivan.net/a/zJAj2Vp.html" rel="bookmark" class="title">Ubuntu12&period;04如何修改窗口背景色为眼睛保护色来保护眼睛，强力推荐！！</a>
					<div>
						             最近突然发现盯着屏幕看的久了,眼睛会非常的痛苦,因此想改变一下系统的窗口背景颜色.其实看代码主要是在Eclipse里面察看,因此一开始我就想改变Eclipse的文本编辑框的背 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPBm1lb.html" rel="bookmark" class="title">未备案网站如何使用CDN加速服务？</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 网站加速,是站长离不开的话题.现在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyeWO8M.html" rel="bookmark" class="title">CentOS 6&period;5 安装 MySQL 5&period;6&period;17 并修改MySQL的root用户密码</a>
					<div>
						单机搭建CentOS-6.5安装MySQL 5.6.17并修改MySQL的root用户密码 Mysql 5.5以后使用了CMake进行安装,参考与以前的区别请参考: http://www.blogja ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M12j9ap.html" rel="bookmark" class="title">Windows 8&period;1 应用再出发 &lpar;WinJS&rpar; - 几种新增控件（1）</a>
					<div>
						原文:Windows 8.1 应用再出发 (WinJS) - 几种新增控件(1) Windows 8.1 和 WinJS 引入了以下新控件和功能,分别是:AppBarCommand.BackButto ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNnxqxM.html" rel="bookmark" class="title">PaperWeekly 第42期 &vert; 基于知识图谱的问答系统关键技术研究 &num;04</a>
					<div>
						作者丨崔万云 学校丨复旦大学博士 研究方向丨问答系统,知识图谱 领域问答的基础在于领域知识图谱.对于特定领域,其高质量.结构化的知识往往是不存在,或者是极少的.本章希望从一般文本描述中抽取富含知识的句 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQjDjZM.html" rel="bookmark" class="title">15日域名注册、续费涨价5-10块 请迅速提交续费</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断淘宝客 站长团购 云主机 技术大厅 据可靠消息,在15日 下周 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze06W0p.html" rel="bookmark" class="title">vs2010 一直找不到引用，是怎么回事</a>
					<div>
						问题描述 我在Ui层次,添加了BLL层的引用,只用已编译就提示找不到,我把引用删了,重新添加也不行,后来我直接引用dll文件,还是不行,刚引用上去还是可以找到的,一旦编译就不行了???求解啊~~ 解决 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL5YJaz.html" rel="bookmark" class="title">MySQL实现批量检查表并进行repair与optimize的方法&lowbar;Mysql</a>
					<div>
						本文实例讲述了MySQL实现批量检查表并进行repair与optimize的方法.分享给大家供大家参考,具体如下: 以下是shell的参考代码: #!/bin/bash host_name=192.1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGr863p.html" rel="bookmark" class="title">解析static在C和C&plus;&plus;中的用法以及区别&lowbar;C 语言</a>
					<div>
						static主要有三个作用:(1)局部静态变量(2)外部静态变量/函数(3)静态数据成员/成员函数 前两种C和C++都有,第三种仅在C++中有,下面分别作以下介绍: 一.局部静态变量在C/C++中,  ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.027 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
